﻿using LINQPad.Extensibility.DataContext;
using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Linq;

namespace DataContextDriverDemo.DynamicDemo
{
	/// <summary>
	/// Wrapper to read/write connection properties. This acts as our ViewModel - we will bind to it in ConnectionDialog.xaml.
	/// </summary>
	class DynamicDemoProperties
	{
		public IConnectionInfo ConnectionInfo { get; private set; }

		XElement DriverData => ConnectionInfo.DriverData;

		public DynamicDemoProperties (IConnectionInfo cxInfo)
		{
			ConnectionInfo = cxInfo;
		}

		// This is how to create custom properties.
		public int RandomPropertyCount
		{
			get => (int?)DriverData.Element ("RandomPropertyCount") ?? 5;
			set => DriverData.SetElementValue ("RandomPropertyCount", value);
		}
	}
}
